package org.artifactory.aql.model;

/**
 * An AQL API representation of a SQL function applied on some physical column
 *
 * @author Uriah Levy
 */
public class AqlSqlFunction {

    private AqlFunctionFieldEnum functionFieldEnum;
    private AqlFunctionTableEnum functionTableEnum;
    private boolean distinct;

    public AqlSqlFunction(AqlFunctionFieldEnum functionFieldEnum, AqlFunctionTableEnum functionTableEnum,
            boolean distinct) {
        this.functionFieldEnum = functionFieldEnum;
        this.functionTableEnum = functionTableEnum;
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public AqlFunctionFieldEnum getFunctionFieldEnum() {
        return functionFieldEnum;
    }

    public AqlFunctionTableEnum getFunctionTableEnum() {
        return functionTableEnum;
    }
}
