#!/usr/bin/env bash

set -e

export PROJECT_ROOT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && cd ../../.. && pwd)"
source "${PROJECT_ROOT_DIR}/build/ci/scripts/lib/buildInfoUtils.sh"
source "${PROJECT_ROOT_DIR}/build/ci/scripts/lib/commonUtils.sh"
source "${PROJECT_ROOT_DIR}/build/ci/scripts/lib/pipelineUtils.sh"

cd "${PROJECT_ROOT_DIR}/artifactory-oss"

function promoteBuildInfo() {
  local branch propertyBagResource
  branch="$(pipeline_gitBranchName)"
  if common_isMilestoneBranch "${branch}"; then
    echo "promote builds to milestone repository"
    buildInfo_promoteBuilds "milestone"
  else
    echo "promote builds to staging repository"
    buildInfo_promoteBuilds "staging"
    propertyBagResource=$(pipeline_detectPropertyBagResourceBasedOnProperty "post_release_run_number")
    write_output "${propertyBagResource}" "post_release_run_number=${run_number}"
  fi
}

function preventPromotionOfMilestoneToRelease() {
  local branch
  branch="$(pipeline_gitBranchName)"
  if common_isMilestoneBranch "${branch}"; then
    echo "[ERROR] It is not allowed to promote milestones to release repository"
    exit 1
  fi
}
