package org.artifactory.storage.binstore.service;


import org.testng.annotations.Test;

import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;

import static org.testng.Assert.assertEquals;
import static org.testng.Assert.assertNotNull;
import static org.testng.Assert.assertNull;

public class GarbageCollectionDatastoreTest {

    @Test
    public void testStore() {
        GarbageCollectionDatastoreService garbageCollectionDatastoreService = new GarbageCollectionDatastoreService();
        assertNull(garbageCollectionDatastoreService.getLastGCRunInfo());
        GarbageCollectorInfo garbageCollectorInfo = new GarbageCollectorInfo(GarbageCollectorStrategy.FULL);
        garbageCollectorInfo.totalSizeCleaned = new AtomicLong(10);
        garbageCollectorInfo.initialSize = 20;
        garbageCollectorInfo.binariesCleaned = new AtomicInteger(5);
        garbageCollectorInfo.setStatus();
        garbageCollectionDatastoreService.saveLastGCRunInfo(garbageCollectorInfo);
        assertNotNull(garbageCollectionDatastoreService.getLastGCRunInfo());
        assertEquals(GarbageCollectorStrategy.FULL, garbageCollectionDatastoreService.getLastGCRunInfo().strategy);
        assertEquals(20, garbageCollectionDatastoreService.getLastGCRunInfo().initialSize);
    }

}